-- SPDX-FileCopyrightText: 2023 CERN (home.cern)
--
-- SPDX-License-Identifier: CERN-OHL-W-2.0+

-- Do not edit.  Generated by cheby 1.5.0 using these options:
--  -i wrtd_adc_fmc_map.cheby --gen-hdl --hdl vhdl
-- Generated on Thu Jan 12 17:18:10 2023 by dlamprid


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;

entity wrtd_adc_fmc_map is
  port (
    rst_n_i              : in    std_logic;
    clk_i                : in    std_logic;
    wb_i                 : in    t_wishbone_slave_in;
    wb_o                 : out   t_wishbone_slave_out;

    -- FMC ADC trigin
    adc_trigin_i         : in    t_wishbone_master_in;
    adc_trigin_o         : out   t_wishbone_master_out;

    -- FMC ADC trigout
    adc_trigout_i        : in    t_wishbone_master_in;
    adc_trigout_o        : out   t_wishbone_master_out
  );
end wrtd_adc_fmc_map;

architecture syn of wrtd_adc_fmc_map is
  signal adr_int                        : std_logic_vector(12 downto 2);
  signal rd_req_int                     : std_logic;
  signal wr_req_int                     : std_logic;
  signal rd_ack_int                     : std_logic;
  signal wr_ack_int                     : std_logic;
  signal wb_en                          : std_logic;
  signal ack_int                        : std_logic;
  signal wb_rip                         : std_logic;
  signal wb_wip                         : std_logic;
  signal adc_trigin_re                  : std_logic;
  signal adc_trigin_we                  : std_logic;
  signal adc_trigin_wt                  : std_logic;
  signal adc_trigin_rt                  : std_logic;
  signal adc_trigin_tr                  : std_logic;
  signal adc_trigin_wack                : std_logic;
  signal adc_trigin_rack                : std_logic;
  signal adc_trigout_re                 : std_logic;
  signal adc_trigout_we                 : std_logic;
  signal adc_trigout_wt                 : std_logic;
  signal adc_trigout_rt                 : std_logic;
  signal adc_trigout_tr                 : std_logic;
  signal adc_trigout_wack               : std_logic;
  signal adc_trigout_rack               : std_logic;
  signal rd_req_d0                      : std_logic;
  signal rd_adr_d0                      : std_logic_vector(12 downto 2);
  signal rd_ack_d0                      : std_logic;
  signal rd_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_req_d0                      : std_logic;
  signal wr_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_sel_d0                      : std_logic_vector(3 downto 0);
  signal wr_ack_d0                      : std_logic;
begin

  -- WB decode signals
  adr_int <= wb_i.adr(12 downto 2);
  wb_en <= wb_i.cyc and wb_i.stb;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_rip <= '0';
      else
        wb_rip <= (wb_rip or (wb_en and not wb_i.we)) and not rd_ack_int;
      end if;
    end if;
  end process;
  rd_req_int <= (wb_en and not wb_i.we) and not wb_rip;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_wip <= '0';
      else
        wb_wip <= (wb_wip or (wb_en and wb_i.we)) and not wr_ack_int;
      end if;
    end if;
  end process;
  wr_req_int <= (wb_en and wb_i.we) and not wb_wip;

  ack_int <= rd_ack_int or wr_ack_int;
  wb_o.ack <= ack_int;
  wb_o.stall <= not ack_int and wb_en;
  wb_o.rty <= '0';
  wb_o.err <= '0';

  -- pipelining for rd-in+rd-out+wr-in+wr-out
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rd_req_d0 <= '0';
        rd_ack_int <= '0';
        wr_req_d0 <= '0';
        wr_ack_int <= '0';
      else
        rd_req_d0 <= rd_req_int;
        rd_adr_d0 <= adr_int;
        rd_ack_int <= rd_ack_d0;
        wb_o.dat <= rd_dat_d0;
        wr_req_d0 <= wr_req_int;
        wr_dat_d0 <= wb_i.dat;
        wr_sel_d0 <= wb_i.sel;
        wr_ack_int <= wr_ack_d0;
      end if;
    end if;
  end process;

  -- Interface adc_trigin
  adc_trigin_tr <= adc_trigin_wt or adc_trigin_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        adc_trigin_rt <= '0';
        adc_trigin_wt <= '0';
      else
        adc_trigin_rt <= (adc_trigin_rt or adc_trigin_re) and not adc_trigin_rack;
        adc_trigin_wt <= (adc_trigin_wt or adc_trigin_we) and not adc_trigin_wack;
      end if;
    end if;
  end process;
  adc_trigin_o.cyc <= adc_trigin_tr;
  adc_trigin_o.stb <= adc_trigin_tr;
  adc_trigin_wack <= adc_trigin_i.ack and adc_trigin_wt;
  adc_trigin_rack <= adc_trigin_i.ack and adc_trigin_rt;
  adc_trigin_o.adr <= ((19 downto 0 => '0') & rd_adr_d0(11 downto 2)) & (1 downto 0 => '0');
  adc_trigin_o.sel <= wr_sel_d0;
  adc_trigin_o.we <= adc_trigin_wt;
  adc_trigin_o.dat <= wr_dat_d0;

  -- Interface adc_trigout
  adc_trigout_tr <= adc_trigout_wt or adc_trigout_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        adc_trigout_rt <= '0';
        adc_trigout_wt <= '0';
      else
        adc_trigout_rt <= (adc_trigout_rt or adc_trigout_re) and not adc_trigout_rack;
        adc_trigout_wt <= (adc_trigout_wt or adc_trigout_we) and not adc_trigout_wack;
      end if;
    end if;
  end process;
  adc_trigout_o.cyc <= adc_trigout_tr;
  adc_trigout_o.stb <= adc_trigout_tr;
  adc_trigout_wack <= adc_trigout_i.ack and adc_trigout_wt;
  adc_trigout_rack <= adc_trigout_i.ack and adc_trigout_rt;
  adc_trigout_o.adr <= ((19 downto 0 => '0') & rd_adr_d0(11 downto 2)) & (1 downto 0 => '0');
  adc_trigout_o.sel <= wr_sel_d0;
  adc_trigout_o.we <= adc_trigout_wt;
  adc_trigout_o.dat <= wr_dat_d0;

  -- Process for write requests.
  process (rd_adr_d0, wr_req_d0, adc_trigin_wack, adc_trigout_wack) begin
    adc_trigin_we <= '0';
    adc_trigout_we <= '0';
    case rd_adr_d0(12 downto 12) is
    when "0" =>
      -- Submap adc_trigin
      adc_trigin_we <= wr_req_d0;
      wr_ack_d0 <= adc_trigin_wack;
    when "1" =>
      -- Submap adc_trigout
      adc_trigout_we <= wr_req_d0;
      wr_ack_d0 <= adc_trigout_wack;
    when others =>
      wr_ack_d0 <= wr_req_d0;
    end case;
  end process;

  -- Process for read requests.
  process (rd_adr_d0, rd_req_d0, adc_trigin_i.dat, adc_trigin_rack,
           adc_trigout_i.dat, adc_trigout_rack) begin
    -- By default ack read requests
    rd_dat_d0 <= (others => 'X');
    adc_trigin_re <= '0';
    adc_trigout_re <= '0';
    case rd_adr_d0(12 downto 12) is
    when "0" =>
      -- Submap adc_trigin
      adc_trigin_re <= rd_req_d0;
      rd_dat_d0 <= adc_trigin_i.dat;
      rd_ack_d0 <= adc_trigin_rack;
    when "1" =>
      -- Submap adc_trigout
      adc_trigout_re <= rd_req_d0;
      rd_dat_d0 <= adc_trigout_i.dat;
      rd_ack_d0 <= adc_trigout_rack;
    when others =>
      rd_ack_d0 <= rd_req_d0;
    end case;
  end process;
end syn;
